
/* 
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/*
 * _gpgme.h
 */

/* Prologue */
#ifndef GAUCHE__GPGME_H
#define GAUCHE__GPGME_H

#include <gauche.h>
#include <gauche/extend.h>

#include "config.h"

#include "gpgmeutil.h"
#include "struct_gpgme_context.h"
#include "struct_gpgme_key_sig.h"
#include "struct_gpgme_tofu_info.h"
#include "struct_gpgme_data.h"
#include "struct_gpgme_new_signature.h"
#include "struct_gpgme_user_id.h"
#include "struct_gpgme_engine_info.h"
#include "struct_gpgme_signature.h"
#include "struct_gpgme_sig_notation.h"
#include "struct_gpgme_verify_result.h"
#include "struct_gpgme_invalid_key.h"
#include "struct_gpgme_sign_result.h"
#include "struct_gpgme_key.h"
#include "struct_gpgme_subkey.h"

SCM_DECL_BEGIN

/*
 * The following entry is a dummy one.
 * Replace it for your declarations.
 */

extern ScmObj test__gpgme( void );

extern ScmObj _g_gpgme_set_passphrase_cb( ScmObj ctx, ScmObj cb_lambda );
extern ScmObj _g_gpgme_check_version( ScmObj require );
extern ScmObj _g_gpgme_new_context( ScmObj ctx );
extern ScmObj _g_gpgme_release_context( ScmObj ctx );
extern ScmObj _g_gpgme_new_data( ScmObj data );
extern ScmObj _g_gpgme_release_data( ScmObj data );
extern ScmObj _g_gpgme_new_data_from_file( ScmObj buf, const char *filename, int copy );
extern ScmObj _g_gpgme_new_data_from_string( ScmObj buf, ScmObj string, int copy );
extern ScmObj _g_gpgme_set_protocol( ScmObj ctx, int protocol );
extern ScmObj _g_gpgme_set_armor( ScmObj ctx, int yesno );
extern ScmObj _g_gpgme_set_textmode( ScmObj ctx, int yesno );
extern ScmObj _g_gpgme_op_keylist_start( ScmObj ctx, const char *pattern, int secret_only );
extern ScmObj _g_gpgme_op_keylist_next( ScmObj ctx, ScmObj key );
extern ScmObj _g_gpgme_op_keylist_end( ScmObj ctx );
extern ScmObj _g_gpgme_get_key( ScmObj ctx, const char *pattern, ScmObj key, int secret_only );
extern ScmObj _g_gpgme_signers_clear( ScmObj ctx );
extern ScmObj _g_gpgme_signers_add( ScmObj ctx, ScmObj key );
extern ScmObj _g_gpgme_op_sign( ScmObj ctx, ScmObj in, ScmObj out, int sign_mode );
extern ScmObj _g_gpgme_op_verify( ScmObj ctx, ScmObj sig, ScmObj signed_text, ScmObj plaintext );
extern ScmObj _g_gpgme_op_verify_result( ScmObj ctx );
extern ScmObj _g_gpgme_op_export_keys( ScmObj ctx, ScmObj keys, int export_mode, ScmObj buf );
extern long long _g_gpgme_data_seek( ScmObj data, long long offset, int whence );
extern long _g_gpgme_data_read( ScmObj data, ScmObj buffer, size_t size );
extern ScmObj _g_gpgme_op_encrypt( ScmObj ctx, ScmObj recp, int flags, ScmObj plain, ScmObj cipher );
extern ScmObj _g_gpgme_op_decrypt( ScmObj ctx, ScmObj cipher, ScmObj plain );
extern ScmObj _g_gpgme_set_pinentry_mode( ScmObj ctx, int mode );
extern ScmObj _g_gpgme_get_pinentry_mode( ScmObj ctx );

/* Epilogue */
SCM_DECL_END

#endif /* GAUCHE__GPGME_H */
