#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

;;; 
;;; one line to give the Gauche-_gpgme and an idea of what it does.
;;; Copyright (C) 2017 aaauuue 

;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
;;; 


(add-load-path ".." :retrive #t)
(define-module crypt.gpgme
  (use srfi-35)
  (use gauche.uvector)
  (use gauche.collection)
  (use gauche.interactive)

  (use _gpgme)

  (export
   ;;; -----constant start-----
   GPGME-DATA-ENCODING-NONE
   GPGME-DATA-ENCODING-BINARY
   GPGME-DATA-ENCODING-BASE64
   GPGME-DATA-ENCODING-ARMOR
   GPGME-DATA-ENCODING-URL
   GPGME-DATA-ENCODING-URLESC
   GPGME-DATA-ENCODING-URL0
   GPGME-DATA-ENCODING-MIME

   GPGME-DATA-TYPE-INVALID
   GPGME-DATA-TYPE-UNKNOWN
   GPGME-DATA-TYPE-PGP-SIGNED
   GPGME-DATA-TYPE-PGP-ENCRYPTED
   GPGME-DATA-TYPE-PGP-OTHER
   GPGME-DATA-TYPE-PGP-KEY
   GPGME-DATA-TYPE-PGP-SIGNATURE
   GPGME-DATA-TYPE-CMS-SIGNED
   GPGME-DATA-TYPE-CMS-ENCRYPTED
   GPGME-DATA-TYPE-CMS-OTHER
   GPGME-DATA-TYPE-X509-CERT
   GPGME-DATA-TYPE-PKCS12


   GPGME-PK-RSA
   GPGME-PK-RSA-E
   GPGME-PK-RSA-S
   GPGME-PK-ELG-E
   GPGME-PK-DSA
   GPGME-PK-ECC
   GPGME-PK-ELG
   GPGME-PK-ECDSA
   GPGME-PK-ECDH
   GPGME-PK-EDDSA

   GPGME-MD-NONE
   GPGME-MD-MD5
   GPGME-MD-SHA1
   GPGME-MD-RMD160
   GPGME-MD-MD2
   GPGME-MD-TIGER
   GPGME-MD-HAVAL
   GPGME-MD-SHA256
   GPGME-MD-SHA384
   GPGME-MD-SHA512
   GPGME-MD-SHA224
   GPGME-MD-MD4
   GPGME-MD-CRC32
   GPGME-MD-CRC32-RFC1510
   GPGME-MD-CRC24-RFC2440

   GPGME-SIG-MODE-NORMAL
   GPGME-SIG-MODE-DETACH
   GPGME-SIG-MODE-CLEAR

   GPGME-VALIDITY-UNKNOWN
   GPGME-VALIDITY-UNDEFINED
   GPGME-VALIDITY-NEVER
   GPGME-VALIDITY-MARGINAL
   GPGME-VALIDITY-FULL
   GPGME-VALIDITY-ULTIMATE

   GPGME-TOFU-POLICY-NONE
   GPGME-TOFU-POLICY-AUTO
   GPGME-TOFU-POLICY-GOOD
   GPGME-TOFU-POLICY-UNKNOWN
   GPGME-TOFU-POLICY-BAD
   GPGME-TOFU-POLICY-ASK

   GPGME-PROTOCOL-OpenPGP
   GPGME-PROTOCOL-CMS
   GPGME-PROTOCOL-GPGCONF
   GPGME-PROTOCOL-ASSUAN
   GPGME-PROTOCOL-G13
   GPGME-PROTOCOL-UISERVER
   GPGME-PROTOCOL-SPAWN
   GPGME-PROTOCOL-DEFAULT
   GPGME-PROTOCOL-UNKNOWN

   GPGME-KEYLIST-MODE-LOCAL
   GPGME-KEYLIST-MODE-EXTERN
   GPGME-KEYLIST-MODE-SIGS
   GPGME-KEYLIST-MODE-SIG-NOTATIONS
   GPGME-KEYLIST-MODE-WITH-SECRET
   GPGME-KEYLIST-MODE-WITH-TOFU
   GPGME-KEYLIST-MODE-EPHEMERAL
   GPGME-KEYLIST-MODE-VALIDATE

   GPGME-PINENTRY-MODE-DEFAULT
   GPGME-PINENTRY-MODE-ASK
   GPGME-PINENTRY-MODE-CANCEL
   GPGME-PINENTRY-MODE-ERROR
   GPGME-PINENTRY-MODE-LOOPBACK

   GPGME-EXPORT-MODE-EXTERN
   GPGME-EXPORT-MODE-MINIMAL
   GPGME-EXPORT-MODE-SECRET
   GPGME-EXPORT-MODE-RAW
   GPGME-EXPORT-MODE-PKCS12

   GPGME-AUDITLOG-HTML
   GPGME-AUDITLOG-WITH-HELP

   GPGME-SIG-NOTATION-HUMAN-READABLE
   GPGME-SIG-NOTATION-CRITICAL

   GPGME-EVENT-START
   GPGME-EVENT-DONE
   GPGME-EVENT-NEXT-KEY
   GPGME-EVENT-NEXT-TRUSTITEM

   GPGME-ENCRYPT-ALWAYS-TRUST
   GPGME-ENCRYPT-NO-ENCRYPT-TO
   GPGME-ENCRYPT-PREPARE
   GPGME-ENCRYPT-EXPECT-SIGN
   GPGME-ENCRYPT-NO-COMPRESS
   GPGME-ENCRYPT-SYMMETRIC
   GPGME-ENCRYPT-THROW-KEYIDS
   GPGME-ENCRYPT-WRAP

   GPGME-DECRYPT-VERIFY
   GPGME-DECRYPT-UNWRAP

   GPGME-SIGSUM-VALID
   GPGME-SIGSUM-GREEN
   GPGME-SIGSUM-RED
   GPGME-SIGSUM-KEY-REVOKED
   GPGME-SIGSUM-KEY-EXPIRED
   GPGME-SIGSUM-SIG-EXPIRED
   GPGME-SIGSUM-KEY-MISSING
   GPGME-SIGSUM-CRL-MISSING
   GPGME-SIGSUM-CRL-TOO-OLD
   GPGME-SIGSUM-BAD-POLICY
   GPGME-SIGSUM-SYS-ERROR
   GPGME-SIGSUM-TOFU-CONFLICT

   GPGME-IMPORT-NEW
   GPGME-IMPORT-UID
   GPGME-IMPORT-SIG
   GPGME-IMPORT-SUBKEY
   GPGME-IMPORT-SECRET

   GPGME-CREATE-SIGN
   GPGME-CREATE-ENCR
   GPGME-CREATE-CERT
   GPGME-CREATE-AUTH
   GPGME-CREATE-NOPASSWD
   GPGME-CREATE-SELFSIGNED
   GPGME-CREATE-NOSTORE
   GPGME-CREATE-WANTPUB
   GPGME-CREATE-WANTSEC
   GPGME-CREATE-FORCE
   GPGME-CREATE-NOEXPIRE

   GPGME-KEYSIGN-LOCAL
   GPGME-KEYSIGN-LFSEP
   GPGME-KEYSIGN-NOEXPIRE


   GPGME-INTERACT-CARD

   GPGME-SPAWN-DETACHED
   GPGME-SPAWN-ALLOW-SET-FG

   GPGME-CONF-BASIC
   GPGME-CONF-ADVANCED
   GPGME-CONF-EXPERT
   GPGME-CONF-INVISIBLE
   GPGME-CONF-INTERNAL


   GPGME-CONF-NONE
   GPGME-CONF-STRING
   GPGME-CONF-INT32
   GPGME-CONF-UINT32

   GPGME-CONF-FILENAME
   GPGME-CONF-LDAP-SERVER
   GPGME-CONF-KEY-FPR
   GPGME-CONF-PUB-KEY
   GPGME-CONF-SEC-KEY
   GPGME-CONF-ALIAS-LIST

   GPGME-CONF-GROUP
   GPGME-CONF-OPTIONAL
   GPGME-CONF-LIST
   GPGME-CONF-RUNTIME
   GPGME-CONF-DEFAULT
   GPGME-CONF-DEFAULT-DESC
   GPGME-CONF-NO-ARG-DESC
   GPGME-CONF-NO-CHANGE

   GPGME-STATUS-EOF
   GPGME-STATUS-ENTER
   GPGME-STATUS-LEAVE
   GPGME-STATUS-ABORT

   GPGME-STATUS-GOODSIG
   GPGME-STATUS-BADSIG
   GPGME-STATUS-ERRSIG

   GPGME-STATUS-BADARMOR

   GPGME-STATUS-RSA-OR-IDEA
   GPGME-STATUS-KEYEXPIRED
   GPGME-STATUS-KEYREVOKED

   GPGME-STATUS-TRUST-UNDEFINED
   GPGME-STATUS-TRUST-NEVER
   GPGME-STATUS-TRUST-MARGINAL
   GPGME-STATUS-TRUST-FULLY
   GPGME-STATUS-TRUST-ULTIMATE

   GPGME-STATUS-SHM-INFO
   GPGME-STATUS-SHM-GET
   GPGME-STATUS-SHM-GET-BOOL
   GPGME-STATUS-SHM-GET-HIDDEN

   GPGME-STATUS-NEED-PASSPHRASE
   GPGME-STATUS-VALIDSIG
   GPGME-STATUS-SIG-ID
   GPGME-STATUS-ENC-TO
   GPGME-STATUS-NODATA
   GPGME-STATUS-BAD-PASSPHRASE
   GPGME-STATUS-NO-PUBKEY
   GPGME-STATUS-NO-SECKEY
   GPGME-STATUS-NEED-PASSPHRASE-SYM
   GPGME-STATUS-DECRYPTION-FAILED
   GPGME-STATUS-DECRYPTION-OKAY
   GPGME-STATUS-MISSING-PASSPHRASE
   GPGME-STATUS-GOOD-PASSPHRASE
   GPGME-STATUS-GOODMDC
   GPGME-STATUS-BADMDC
   GPGME-STATUS-ERRMDC
   GPGME-STATUS-IMPORTED
   GPGME-STATUS-IMPORT-OK
   GPGME-STATUS-IMPORT-PROBLEM
   GPGME-STATUS-IMPORT-RES
   GPGME-STATUS-FILE-START
   GPGME-STATUS-FILE-DONE
   GPGME-STATUS-FILE-ERROR

   GPGME-STATUS-BEGIN-DECRYPTION
   GPGME-STATUS-END-DECRYPTION
   GPGME-STATUS-BEGIN-ENCRYPTION
   GPGME-STATUS-END-ENCRYPTION

   GPGME-STATUS-DELETE-PROBLEM
   GPGME-STATUS-GET-BOOL
   GPGME-STATUS-GET-LINE
   GPGME-STATUS-GET-HIDDEN
   GPGME-STATUS-GOT-IT
   GPGME-STATUS-PROGRESS
   GPGME-STATUS-SIG-CREATED
   GPGME-STATUS-SESSION-KEY
   GPGME-STATUS-NOTATION-NAME
   GPGME-STATUS-NOTATION-DATA
   GPGME-STATUS-POLICY-URL
   GPGME-STATUS-BEGIN-STREAM
   GPGME-STATUS-END-STREAM
   GPGME-STATUS-KEY-CREATED
   GPGME-STATUS-USERID-HINT
   GPGME-STATUS-UNEXPECTED
   GPGME-STATUS-INV-RECP
   GPGME-STATUS-NO-RECP
   GPGME-STATUS-ALREADY-SIGNED
   GPGME-STATUS-SIGEXPIRED
   GPGME-STATUS-EXPSIG
   GPGME-STATUS-EXPKEYSIG
   GPGME-STATUS-TRUNCATED
   GPGME-STATUS-ERROR
   GPGME-STATUS-NEWSIG
   GPGME-STATUS-REVKEYSIG
   GPGME-STATUS-SIG-SUBPACKET
   GPGME-STATUS-NEED-PASSPHRASE-PIN
   GPGME-STATUS-SC-OP-FAILURE
   GPGME-STATUS-SC-OP-SUCCESS
   GPGME-STATUS-CARDCTRL
   GPGME-STATUS-BACKUP-KEY-CREATED
   GPGME-STATUS-PKA-TRUST-BAD
   GPGME-STATUS-PKA-TRUST-GOOD
   GPGME-STATUS-PLAINTEXT
   GPGME-STATUS-INV-SGNR
   GPGME-STATUS-NO-SGNR
   GPGME-STATUS-SUCCESS
   GPGME-STATUS-DECRYPTION-INFO
   GPGME-STATUS-PLAINTEXT-LENGTH
   GPGME-STATUS-MOUNTPOINT
   GPGME-STATUS-PINENTRY-LAUNCHED
   GPGME-STATUS-ATTRIBUTE
   GPGME-STATUS-BEGIN-SIGNING
   GPGME-STATUS-KEY-NOT-CREATED
   GPGME-STATUS-INQUIRE-MAXLEN
   GPGME-STATUS-FAILURE
   GPGME-STATUS-KEY-CONSIDERED
   GPGME-STATUS-TOFU-USER
   GPGME-STATUS-TOFU-STATS
   GPGME-STATUS-TOFU-STATS-LONG
   GPGME-STATUS-NOTATION-FLAGS

   GPGME-SIG-STAT-NONE
   GPGME-SIG-STAT-GOOD
   GPGME-SIG-STAT-BAD
   GPGME-SIG-STAT-NOKEY
   GPGME-SIG-STAT-NOSIG
   GPGME-SIG-STAT-ERROR
   GPGME-SIG-STAT-DIFF
   GPGME-SIG-STAT-GOOD-EXP
   GPGME-SIG-STAT-GOOD-EXPKEY

   GPGME-ATTR-KEYID
   GPGME-ATTR-FPR
   GPGME-ATTR-ALGO
   GPGME-ATTR-LEN
   GPGME-ATTR-CREATED
   GPGME-ATTR-EXPIRE
   GPGME-ATTR-OTRUST
   GPGME-ATTR-USERID
   GPGME-ATTR-NAME
   GPGME-ATTR-EMAIL
   GPGME-ATTR-COMMENT
   GPGME-ATTR-VALIDITY
   GPGME-ATTR-LEVEL
   GPGME-ATTR-TYPE
   GPGME-ATTR-IS-SECRET
   GPGME-ATTR-KEY-REVOKED
   GPGME-ATTR-KEY-INVALID
   GPGME-ATTR-UID-REVOKED
   GPGME-ATTR-UID-INVALID
   GPGME-ATTR-KEY-CAPS
   GPGME-ATTR-CAN-ENCRYPT
   GPGME-ATTR-CAN-SIGN
   GPGME-ATTR-CAN-CERTIFY
   GPGME-ATTR-KEY-EXPIRED
   GPGME-ATTR-KEY-DISABLED
   GPGME-ATTR-SERIAL
   GPGME-ATTR-ISSUER
   GPGME-ATTR-CHAINID
   GPGME-ATTR-SIG-STATUS
   GPGME-ATTR-ERRTOK
   GPGME-ATTR-SIG-SUMMARY
   GPGME-ATTR-SIG-CLASS

   ;;; -----constant end-----

   <gpgme-context>
   <gpgme-data>
   <gpgme-engine-info>
   <gpgme-invalid-key>
   <gpgme-key>
   <gpgme-key-sig>
   <gpgme-new-signature>
   <gpgme-sig-notation>
   <gpgme-sign-result>
   <gpgme-signature>
   <gpgme-subkey>
   <gpgme-tofu-info>
   <gpgme-user-id>
   <gpgme-verify-result>

   <gpgme-error>
   gpgme-error?
   gpgme-error-debug-info
   gpgme-error-message
   
   default-passphrase-cb
   init-gpgme
   gpgme-check-version
   gpgme-new-context
   gpgme-release-context
   gpgme-new-data
   gpgme-release-data
   gpgme-new-data-from-file
   gpgme-new-data-from-string
   gpgme-set-protocol
   gpgme-set-armor
   gpgme-set-textmode
   gpgme-op-keylist-start
   gpgme-op-keylist-next
   gpgme-op-keylist-end
   gpgme-get-key
   gpgme-signers-clear
   gpgme-signers-add
   gpgme-op-sign
   gpgme-op-verify
   gpgme-op-verify-result
   gpgme-op-export-keys
   gpgme-op-encrypt
   gpgme-op-decrypt
   gpgme-set-passphrase-cb
   gpgme-set-pinentry-mode
   gpgme-get-pinentry-mode
   data-read
   gpgme-export-keys
   gpgme-sign-file
   gpgme-sign-string
   gpgme-verify-file-sign
   gpgme-verify-string-sign
   gpgme-verify-validation
   gpgme-encrypt-file
   gpgme-encrypt-string
   gpgme-decrypt-file
   gpgme-decrypt-string
   <gpgme-keylist-meta>
   <gpgme-keylist-meta!>
   <gpgme-subkeylist-meta>
   <gpgme-keylist> 
   <gpgme-keylist!> 
   <gpgme-subkeylist> 
   call-with-iterator
   call-with-gpgme-context
   with-gpgme-armor
   ))



(select-module crypt.gpgme)
(dynamic-load "_gpgme")

(define-condition-type <gpgme-error> <error>
  gpgme-error?
  (debug-info gpgme-error-debug-info)
  (message gpgme-error-message))

(define-syntax gpgme-try
  (syntax-rules ()
    [(_ body ...)
     (receive (a b c d)
         body ...
         (if (not (= a 0))
           (raise
            (condition
             (<gpgme-error>
              (debug-info (format "~d: ~S ~S" a b c))
              (message d))))))]
    [(_ . ?) (syntax-error "malformed syntax " (gpgme-try . body))]))

(define-syntax tf->number
  (syntax-rules ()
    [(_ value)
     (if value 1 0)]))

(define (default-passphrase-cb opapue uid-hint passphrase-info last-was-bad oport)
  (raise (condition
          (<gpgme-error>
           (debug-info (format "~a\n~a\n~S\n" uid-hint passphrase-info last-was-bad))
           (message "Define your original passphrase-cb for sign, encrypt, decrypt or any other works that was required by GPGME.
Original passphrase-cb defines like this.

(define (original-passphrase-cb opapue uid-hint passphrase-info last-was-bad oport)
  ....
  ;; Write passphrase to oport.
  ....)
")))))



(define (init-gpgme)
  (%init-gpgme))

(define (gpgme-check-version :optional (required ""))
  (%gpgme-check-version required))

(define (gpgme-new-context)
  (let ([obj (make <gpgme-context>)])
    (gpgme-try (%gpgme-new-context obj))
    obj))

(define (gpgme-release-context ctx)
  (gpgme-try (%gpgme-release-context ctx)))

(define (gpgme-new-data)
  (let ([obj (make <gpgme-data>)])
    (gpgme-try (%gpgme-new-data obj))
    obj))

(define (gpgme-release-data data)
  (gpgme-try (%gpgme-release-data data)))

(define (gpgme-new-data-from-file file-name copy)
  (let ([buf (gpgme-new-data)])
    (gpgme-try (%gpgme-new-data-from-file buf file-name copy))
    buf))

(define (gpgme-new-data-from-string string copy)
  (let ([buf (gpgme-new-data)])
    (gpgme-try (%gpgme-new-data-from-string buf string copy))
    buf))

(define (gpgme-set-protocol ctx protocol)
  (gpgme-try (%gpgme-set-protocol ctx protocol)))

(define (gpgme-set-armor ctx value)
  (gpgme-try (%gpgme-set-armor ctx (tf->number value))))

(define (gpgme-set-textmode ctx value)
  (gpgme-try (%gpgme-set-textmode ctx (tf->number value))))

(define (gpgme-op-keylist-start ctx pattern secret-only)
  (gpgme-try (%gpgme-op-keylist-start
              ctx pattern (tf->number secret-only))))

(define (gpgme-op-keylist-next ctx key)
  (gpgme-try (%gpgme-op-keylist-next ctx key))
  key)

(define (gpgme-op-keylist-end ctx)
  (gpgme-try (%gpgme-op-keylist-end ctx)))

(define (gpgme-get-key ctx pattern secret-only)
  (let ([key (make <gpgme-key>)])
    (gpgme-try (%gpgme-get-key ctx pattern key (tf->number secret-only)))
    key))

(define (gpgme-signers-clear ctx)
  (gpgme-try (%gpgme-signers-clear ctx)))

(define (gpgme-signers-add ctx key)
  (gpgme-try (%gpgme-signers-add ctx key)))

(define (gpgme-op-sign ctx in sign-mode)
  (let ([out (gpgme-new-data)])
    (gpgme-try (%gpgme-op-sign ctx in out sign-mode))
    out))

(define (gpgme-op-verify ctx sig signed-text detach)
  (let ([plaintext (gpgme-new-data)])
    (if (eq? detach #t)
      (gpgme-try (%gpgme-op-verify ctx sig signed-text #f))
      (gpgme-try (%gpgme-op-verify ctx sig signed-text plaintext)))
    plaintext))

(define (gpgme-op-verify-result ctx)
  (%gpgme-op-verify-result ctx))

(define (gpgme-op-export-keys ctx keys export-mode)
  (let ([buf (gpgme-new-data)])
    (gpgme-try (%gpgme-op-export-keys ctx keys export-mode buf))
    buf))

(define (gpgme-op-encrypt ctx recp-keys flags plain)
  (let ([cipher (gpgme-new-data)])
    (gpgme-try (%gpgme-op-encrypt ctx recp-keys flags plain cipher))
    cipher))

(define (gpgme-op-decrypt ctx cipher)
  (let ([plain (gpgme-new-data)])
    (gpgme-try (%gpgme-op-decrypt ctx cipher plain))
    plain))

(define (gpgme-set-passphrase-cb ctx
                                 :optional (passphrase-cb
                                            default-passphrase-cb))
  (%gpgme-set-passphrase-cb ctx passphrase-cb))

(define (gpgme-set-pinentry-mode ctx mode)
  (gpgme-try (%gpgme-set-pinentry-mode ctx mode)))

(define (gpgme-get-pinentry-mode ctx)
  (%gpgme-get-pinentry-mode ctx))



(define (data-read buf out :key (size 512))
  (let ([out-buf (make-uvector <u8vector> size)]
        [write-size 0])
    (%gpgme-data-seek buf 0 0)
    (set! write-size (%gpgme-data-read buf out-buf size))
    (while (> write-size 0)
      (write-uvector out-buf out 0 write-size)
      (set! write-size (%gpgme-data-read buf out-buf size)))))

(define (gpgme-export-keys ctx keys export-mode 
                           :key (oport (current-output-port)))
  (let ([buf #f])
    (set! buf (gpgme-op-export-keys ctx keys export-mode))
    (data-read buf oport)
    (gpgme-release-data buf)))

(define (gpgme-sign-function proc ctx src recps sign-mode oport)
  (let ([buf (proc src 1)]
        [out #f])
    (gpgme-signers-clear ctx)
    (dolist (recp recps)
      (let ([key (gpgme-get-key ctx recp #f)])
        (gpgme-signers-add ctx key)))
    (set! out (gpgme-op-sign ctx buf sign-mode))
    (data-read out oport)
    (gpgme-release-data buf)
    (gpgme-release-data out)))

(define (gpgme-sign-file ctx file-name recps sign-mode
                         :key (oport (current-output-port)))
  (gpgme-sign-function gpgme-new-data-from-file
                       ctx file-name recps sign-mode oport))

(define (gpgme-sign-string ctx string recps sign-mode
                           :key (oport (current-output-port)))
  (gpgme-sign-function gpgme-new-data-from-string
                       ctx string recps sign-mode oport))

(define (gpgme-verify-sign-function proc ctx sign signed-text detach oport)
  (let ([vresult #f]
        [sign-buf (proc sign 1)]
        [signed (proc signed-text 1)]
        [plain #f])
    (set! plain (gpgme-op-verify ctx sign-buf signed detach))
    (set! vresult (gpgme-op-verify-result ctx))
    (data-read plain oport)
    vresult))

(define (gpgme-verify-file-sign ctx sign signed-text
                                :key (detach #f) (oport (current-output-port)))
  (gpgme-verify-sign-function gpgme-new-data-from-file ctx sign signed-text
                              detach oport))

(define (gpgme-verify-string-sign ctx sign signed-text
                                  :key (detach #f) (oport (current-output-port)))
  (gpgme-verify-sign-function gpgme-new-data-from-string ctx sign signed-text
                              detach oport))

(define (gpgme-verify-validation vresult)
  (if (= (logand (~ vresult'signatures'summary) GPGME-SIGSUM-VALID) 1) ;;; validation
    #t
    #f))

(define (gpgme-encrypt-function proc ctx src recps flags
                                passphrase-cb symmetric oport)
  (let ([buf (proc src 1)]
        [cipher #f]
        [keys '()])
    (if (eq? symmetric #f)
      (dolist (recp recps)
        (set! keys (append keys (list (gpgme-get-key ctx recp #f))))))
    (gpgme-set-passphrase-cb ctx passphrase-cb)
    (set! cipher (gpgme-op-encrypt ctx keys flags buf))
    (data-read cipher oport)
    (gpgme-release-data buf)
    (gpgme-release-data cipher)))

(define (gpgme-encrypt-file ctx file-name recps flags
                            :key (passphrase-cb default-passphrase-cb)
                            (symmetric #f)
                            (oport (current-output-port)))
  (gpgme-encrypt-function gpgme-new-data-from-file ctx file-name recps flags
                          passphrase-cb symmetric oport))

(define (gpgme-encrypt-string ctx string recps flags
                              :key (passphrase-cb default-passphrase-cb)
                              (symmetric #f)
                              (oport (current-output-port)))
  (gpgme-encrypt-function gpgme-new-data-from-string ctx string recps flags
                          passphrase-cb symmetric oport))

(define (gpgme-decrypt-function proc ctx src passphrase-cb oport)
  (let ([buf (proc src 1)]
        [out #f])
    (gpgme-set-passphrase-cb ctx passphrase-cb)
    (set! out (gpgme-op-decrypt ctx buf))
    (data-read out oport)
    (gpgme-release-data buf)
    (gpgme-release-data out)))

(define (gpgme-decrypt-file ctx file-name
                            :key (passphrase-cb default-passphrase-cb)
                            (oport (current-output-port)))
  (gpgme-decrypt-function gpgme-new-data-from-file ctx file-name
                          passphrase-cb oport))

(define (gpgme-decrypt-string ctx string
                              :key (passphrase-cb default-passphrase-cb)
                              (oport (current-output-port)))
  (gpgme-decrypt-function gpgme-new-data-from-string ctx string
                          passphrase-cb oport))




(define-class <gpgme-keylist-meta> (<class>) ())
(define-class <gpgme-keylist-meta!> (<class>) ())
(define-class <gpgme-subkeylist-meta> (<class>) ())
(define-class <gpgme-keylist> (<collection>)
  ((ctx :init-value #f :init-keyword :ctx))
  :metaclass <gpgme-keylist-meta>)
(define-class <gpgme-keylist!> (<collection>)
  ((ctx :init-value #f :init-keyword :ctx))
  :metaclass <gpgme-keylist-meta!>)
(define-class <gpgme-subkeylist> (<collection>)
  ((subkey :init-value #f :init-keyword :subkey))
  :metaclass <gpgme-subkeylist-meta>)

(define-method call-with-iterator ((self <gpgme-keylist>) proc . opts)
  (let* ([ctx (~ self'ctx)]
         [ret-code 1]
         [key #f])
    (%gpgme-op-keylist-start ctx "" 0)
    (proc
     (lambda ()
       (set! key (make <gpgme-key>))
       (receive (a b c d)
           (%gpgme-op-keylist-next ctx key)
         (set! ret-code a))
       (if (not (= ret-code 0))
         (begin (%gpgme-op-keylist-end ctx) #t)
         #f))
     (lambda () key))))

(define-method call-with-iterator ((self <gpgme-keylist!>) proc . opts)
  (let* ([ctx (~ self'ctx)]
         [key (make <gpgme-key>)]
         [ret-code 0])
    (%gpgme-op-keylist-start ctx "" 0)
    (proc
     (lambda ()
       (receive (a b c d)
           (%gpgme-op-keylist-next ctx key)
         (set! ret-code a))
       (if (not (= ret-code 0))
         (begin (%gpgme-op-keylist-end ctx) #t)
         #f))
     (lambda ()
       (if (= ret-code 0) key)))))

(define-method call-with-iterator ((self <gpgme-subkeylist>) proc . opts)
  (let ([subkey (~ self'subkey)])
    (proc
     (lambda ()
       (set! subkey (~ subkey'next))
       (if (eq? subkey #f) #t #f))
     (lambda () subkey))))



(define (call-with-gpgme-context proc)
  (let ([ctx (gpgme-new-context)])
    (unwind-protect
     (proc ctx)
     (gpgme-release-context ctx))))

(define-syntax with-gpgme-armor
  (syntax-rules ()
    [(_ ctx body ...)
     (unwind-protect
      (begin
        (gpgme-set-armor ctx #t)
        body ...)
      (gpgme-set-armor ctx #f))]))

(provide "crypt/gpgme")
