#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

(use crypt.gpgme)
(use gauche.interactive)
(use gauche.collection)
(use gauche.generator)

(init-gpgme)

;;; Get key
(let ([ctx (gpgme-new-context)]
      [key #f])
  (set! key (gpgme-get-key ctx "foo@hoge.com" #f))
  (describe key)
  (describe (~ key'uids))
  (gpgme-release-context ctx))

;;; Export key
(let ([ctx (gpgme-new-context)]
      [key1 #f]
      [key2 #f])
  (gpgme-set-armor ctx #t) ;;; text mode
  (set! key1 (gpgme-get-key ctx "foo@hoge.com" #f))
  (describe (~ key1'uids))
  (set! key2 (gpgme-get-key ctx "bar@hoge.com" #f))
  (describe (~ key2'uids))

  ;;; export public key
  (gpgme-export-keys ctx (list key1 key2) GPGME-EXPORT-MODE-MINIMAL)

  ;;; export private key
  (gpgme-export-keys ctx (list key1 key2) GPGME-EXPORT-MODE-SECRET)
  (gpgme-release-context ctx))

;;; Iterate keys
(let* ([ctx (gpgme-new-context)]
       [keylist (make <gpgme-keylist> :ctx ctx)]
       [keylist! (make <gpgme-keylist!> :ctx ctx)]
       [klst '()])

  (set! klst (filter (^x ($ not $ eq? x #f)) keylist))
  (set! klst (map identity keylist))
  (dolist (key klst)
    (describe (~ key'uids))
    (let ([subkey (make <gpgme-subkeylist> :subkey (~ key'subkeys))])
      (map (^x (describe x)) subkey)))

  ;;; Iterate keys used by generator.
  (let ([g #f])
    (set! g (x->generator keylist!))
    (describe (~ (g) 'uids))
    (describe (~ (g) 'uids))
    (describe (~ (g) 'uids)))

  (gpgme-release-context ctx))
