#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

(use crypt.gpgme)
(use gauche.collection)
(use gauche.generator)
(use file.util)

(init-gpgme)

(define (passphrase-cb opaque uid-hint passphrase-info last-was-bad oport)
  (format oport "foobar\n")
  0)

(call-with-gpgme-context
 (^(ctx)
   (with-gpgme-armor
    ctx
    (guard
        (exc
         [(gpgme-error? exc)
          (format #t "~a~a\n"
                  (gpgme-error-debug-info exc)
                  (gpgme-error-message exc))])
      (let ([out (open-output-string)]
            [vresult #f])
        ;;; for GunPG >= 2.1.
        ;; (gpgme-set-pinentry-mode ctx GPGME-PINENTRY-MODE-LOOPBACK)
        ;; 
        (gpgme-set-passphrase-cb ctx passphrase-cb)
        (gpgme-sign-file ctx "./gpgme01.scm" '("foo@hoge.com")
                         GPGME-SIG-MODE-DETACH :oport out)
        (format #t "sign\n~a\n" (get-output-string out))
        (set! vresult (gpgme-verify-string-sign ctx (get-output-string out)
                                                (file->string "./gpgme01.scm")
                                                :detach #t))
        (if (gpgme-verify-validation vresult)
          (format #t "gpgme01.scm's sign is valid.\n")
          (format #t "Invalid sign.\n"))
        )))))

(call-with-gpgme-context
 (^(ctx)
   (with-gpgme-armor
    ctx
    (guard
        (exc
         [(gpgme-error? exc)
          (format #t "~a~a\n"
                  (gpgme-error-debug-info exc)
                  (gpgme-error-message exc))])
      (let ([out (open-output-string)]
            [vresult #f]
            [signed-text "crypt.gpgme is gpgme binding.\n"]
            [plain (open-output-string)])
        ;;; For GunPG >= 2.1. If you don't call this function with
        ;;; GPGME-PINENTRY-MODE-LOOPBACK, passphrase callback function that
        ;;; you set by gpgme-set-passphrase-cb function is ignored and input
        ;;; passphrase from pinentry program.
        ;;; 
        ;; (gpgme-set-pinentry-mode ctx GPGME-PINENTRY-MODE-LOOPBACK)
        ;; 
        (gpgme-set-passphrase-cb ctx passphrase-cb)
        (gpgme-sign-string ctx signed-text '("foo@hoge.com")
                           GPGME-SIG-MODE-NORMAL :oport out)
        (format #t "sign\n~a\n" (get-output-string out))
        (set! vresult (gpgme-verify-string-sign
                       ctx (get-output-string out) signed-text :detach #f
                       :oport plain))
        (format #t "plain text [~a]\n" (get-output-string plain))
        (if (gpgme-verify-validation vresult)
          (format #t "Sign is valid.\n")
          (format #t "Invalid sign.\n"))
        )))))

(call-with-gpgme-context
 (^(ctx)
   (with-gpgme-armor
    ctx
    (guard
        (exc
         [(gpgme-error? exc)
          (format #t "~a~a\n"
                  (gpgme-error-debug-info exc)
                  (gpgme-error-message exc))])
      (let ([out (open-output-string)]
            [vresult #f])
        ;;; For GunPG >= 2.1. If you don't call this function with
        ;;; GPGME-PINENTRY-MODE-LOOPBACK, passphrase callback function that
        ;;; you set by gpgme-set-passphrase-cb function is ignored and input
        ;;; passphrase from pinentry program.
        ;;; 
        ;; (gpgme-set-pinentry-mode ctx GPGME-PINENTRY-MODE-LOOPBACK)
        ;; 
        (gpgme-set-passphrase-cb ctx passphrase-cb)
        (gpgme-sign-file ctx "./gpgme01.scm" '("foo@hoge.com")
                         GPGME-SIG-MODE-CLEAR :oport out)
        (format #t "sign\n~a\n" (get-output-string out))
        (set! vresult #?=(gpgme-verify-string-sign ctx (get-output-string out)
                                                   (file->string "./gpgme01.scm")
                                                   :detach #f))
        (if (gpgme-verify-validation vresult)
          (format #t "gpgme01.scm's sign is valid.\n")
          (format #t "Invalid sign.\n"))
        )))))
