#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

(use crypt.gpgme)
(use gauche.collection)

(init-gpgme)

(define (passphrase-cb opaque uid-hint passphrase-info last-was-bad oport)
  (format oport "foobar\n")
  0)

(define (passphrase-cb-for-symmetric opaque uid-hint passphrase-info
                                     last-was-bad oport)
  (format oport "hogehoge\n")
  0)


(call-with-gpgme-context
 (^(ctx)
   (with-gpgme-armor
    ctx
    (guard
        (exc
         [(gpgme-error? exc)
          (format #t "~a~a\n"
                  (gpgme-error-debug-info exc)
                  (gpgme-error-message exc))])
      (let ([encrypt-string "Encrypt string.\n"]
            [out (open-output-string)])

        ;;; For GunPG >= 2.1. If you don't call this function with
        ;;; GPGME-PINENTRY-MODE-LOOPBACK, passphrase callback function that
        ;;; you set by gpgme-set-passphrase-cb function is ignored and input
        ;;; passphrase from pinentry program.
        ;;; 
        ;; (gpgme-set-pinentry-mode ctx GPGME-PINENTRY-MODE-LOOPBACK)
        ;; 
        (gpgme-encrypt-string ctx encrypt-string '("foo@hoge.com")
                              GPGME-ENCRYPT-ALWAYS-TRUST
                              :passphrase-cb passphrase-cb
                              :oport out)
        (format #t "Encrypt string [~a]\n" (get-output-string out))
        (format #t "\nDecrypt\n")
        (gpgme-decrypt-string ctx (get-output-string out)
                              :passphrase-cb passphrase-cb))))))

            
(call-with-gpgme-context
 (^(ctx)
   (with-gpgme-armor
    ctx
    (guard
        (exc
         [(gpgme-error? exc)
          (format #t "~a ~a\n"
                  (gpgme-error-debug-info exc)
                  (gpgme-error-message exc))])
      (let ([encrypt-string "Encrypt string.\n"]
            [out (open-output-string)])

        ;;; Using symmetric
        ;;; For GunPG >= 2.1. If you don't call this function with
        ;;; GPGME-PINENTRY-MODE-LOOPBACK, passphrase callback function that
        ;;; you set by gpgme-set-passphrase-cb function is ignored and input
        ;;; passphrase from pinentry program.
        ;;; 
        ;; (gpgme-set-pinentry-mode ctx GPGME-PINENTRY-MODE-LOOPBACK)
        ;; 
        (gpgme-encrypt-string ctx encrypt-string '()
                              GPGME-ENCRYPT-ALWAYS-TRUST
                              :symmetric #t
                              :passphrase-cb passphrase-cb-for-symmetric
                              :oport out)
        (format #t "Encrypt string [~a]\n" (get-output-string out))
        (format #t "\nDecrypt\n")
        (gpgme-decrypt-string ctx (get-output-string out)
                              :passphrase-cb passphrase-cb-for-symmetric))))))


