
/* 
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "gpgmeutil.h"

void init_gpgme( void )
{
     /* Initialize the locale environment. */
#ifdef HAVE_LOCALE_H
     setlocale( LC_ALL, "" );
#endif /* #ifdef HAVE_LOCALE_H */
     
     gpgme_check_version( NULL );

#ifdef HAVE_LOCALE_H
     gpgme_set_locale( NULL, LC_CTYPE, setlocale( LC_CTYPE, NULL ) );

#       ifdef LC_MESSAGES
     gpgme_set_locale( NULL, LC_MESSAGES, setlocale( LC_MESSAGES, NULL ) );
#       endif /* #       ifdef LC_MESSAGES */

#endif /* #ifdef HAVE_LOCALE_H */

}

/* from gpgme test code */
void print_data( gpgme_data_t dh )
{
#define BUF_SIZE 512
     char buf[BUF_SIZE + 1];
     int  ret;

     ret = gpgme_data_seek( dh, 0, SEEK_SET );
     if( ret )
          fail_if_err( gpgme_err_code_from_errno( errno ) );
     while( ( ret = gpgme_data_read( dh, buf, BUF_SIZE ) ) > 0 )
          fwrite( buf, ret, 1, stdout );
     if( ret < 0 )
          fail_if_err( gpgme_err_code_from_errno( errno ) );

     /* Reset read position to the beginning so that dh can be used as input
        for another operation after this method call. For example, dh is an
        output from encryption and also is used as an input for decryption.
        Otherwise GPG_ERR_NO_DATA is returned since this method moves the
        read position. */
     ret = gpgme_data_seek( dh, 0, SEEK_SET );
}

char *nullout( char *src )
{
     if( src == NULL ) {
          return "";
     }

     return src;
}

void print_key( gpgme_key_t key )
{
     gpgme_subkey_t subkey;
     
     if( key ) {
          printf( "---keys---\n" );
          printf( "invalid %d\n" \
                  "fingerprint: [%s]\n" \
                  "uid: [%s]\n" \
                  "name: [%s]\n" \
                  "email: [%s]\n",
                  key->invalid,
                  nullout( key->fpr ),
                  nullout( key->_last_uid->uid ),
                  nullout( key->_last_uid->name ),
                  nullout( key->_last_uid->email ) 
                  );
          subkey = key->subkeys;
          while( subkey != NULL ) {
               printf( "===subkey===\n" );
               printf( "keyid: [%s]\n" \
                       "fingerprint: [%s]\n" \
                       "keygrip: [%s]\n",
                       nullout( subkey->keyid ),
                       nullout( subkey->fpr ),
                       nullout( subkey->keygrip )
                       );
               subkey = subkey->next;
          }
     }
}


#if 0
int main( int argc, char **argv )
{
     return 0;
}
#endif


/* 
 * Local variables:
 * compile-command: "gcc -std=c99 -g3 -o gpgmeutil gpgmeutil.c"
 * End:
 */
