
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_engine_info.h"

ScmObj gpgme_engine_info_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_ENGINE_INFO *p = SCM_NEW( Scm_GPGME_ENGINE_INFO );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_ENGINE_INFO );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_ENGINE_INFOClass, NULL, NULL, NULL,
                          gpgme_engine_info_allocate, NULL );

ScmObj gpgme_engine_info_protocol( Scm_GPGME_ENGINE_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->protocol );
}

ScmObj gpgme_engine_info_file_name( Scm_GPGME_ENGINE_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->file_name == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->file_name );
     }
}

ScmObj gpgme_engine_info_version( Scm_GPGME_ENGINE_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->version == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->version );
     }
}

ScmObj gpgme_engine_info_req_version( Scm_GPGME_ENGINE_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->req_version == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->req_version );
     }
}

ScmObj gpgme_engine_info_home_dir( Scm_GPGME_ENGINE_INFO *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->home_dir == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->home_dir );
     }
}
