#ifndef __STRUCT_GPGME_ENGINE_INFO_H__
#define __STRUCT_GPGME_ENGINE_INFO_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_ENGINE_INFORec {
     SCM_HEADER;
     gpgme_engine_info_t obj;
} Scm_GPGME_ENGINE_INFO;

SCM_CLASS_DECL( Scm_GPGME_ENGINE_INFOClass );
#define SCM_CLASS_GPGME_ENGINE_INFO ( &Scm_GPGME_ENGINE_INFOClass )
#define SCM_GPGME_ENGINE_INFO( obj ) ( ( Scm_GPGME_ENGINE_INFO * )obj )
#define SCM_GPGME_ENGINE_INFO_P( obj )                                         \
     SCM_XTYPEP( obj, &Scm_GPGME_ENGINE_INFOClass )

ScmObj gpgme_engine_info_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_engine_info_protocol( Scm_GPGME_ENGINE_INFO *p );
ScmObj gpgme_engine_info_file_name( Scm_GPGME_ENGINE_INFO *p );
ScmObj gpgme_engine_info_version( Scm_GPGME_ENGINE_INFO *p );
ScmObj gpgme_engine_info_req_version( Scm_GPGME_ENGINE_INFO *p );
ScmObj gpgme_engine_info_home_dir( Scm_GPGME_ENGINE_INFO *p );

static ScmClassStaticSlotSpec gpgme_engine_info_slots[] = {
     SCM_CLASS_SLOT_SPEC( "protocol", gpgme_engine_info_protocol, NULL ),
     SCM_CLASS_SLOT_SPEC( "file_name", gpgme_engine_info_file_name, NULL ),
     SCM_CLASS_SLOT_SPEC( "version", gpgme_engine_info_version, NULL ),
     SCM_CLASS_SLOT_SPEC( "req_version", gpgme_engine_info_req_version, NULL ),
     SCM_CLASS_SLOT_SPEC( "home_dir", gpgme_engine_info_home_dir, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_ENGINE_INFO_H__ */
