#ifndef __STRUCT_GPGME_INVALID_KEY_H__
#define __STRUCT_GPGME_INVALID_KEY_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_INVALID_KEYRec {
     SCM_HEADER;
     gpgme_invalid_key_t obj;
} Scm_GPGME_INVALID_KEY;

SCM_CLASS_DECL( Scm_GPGME_INVALID_KEYClass );
#define SCM_CLASS_GPGME_INVALID_KEY ( &Scm_GPGME_INVALID_KEYClass )
#define SCM_GPGME_INVALID_KEY( obj ) ( ( Scm_GPGME_INVALID_KEY * )obj )
#define SCM_GPGME_INVALID_KEY_P( obj )                                         \
     SCM_XTYPEP( obj, &Scm_GPGME_INVALID_KEYClass )

ScmObj gpgme_invalid_key_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_invalid_key_next( Scm_GPGME_INVALID_KEY *p );
ScmObj gpgme_invalid_key_fpr( Scm_GPGME_INVALID_KEY *p );
ScmObj gpgme_invalid_key_reason( Scm_GPGME_INVALID_KEY *p );

static ScmClassStaticSlotSpec gpgme_invalid_key_slots[] = {
     SCM_CLASS_SLOT_SPEC( "next", gpgme_invalid_key_next, NULL ),
     SCM_CLASS_SLOT_SPEC( "fpr", gpgme_invalid_key_fpr, NULL ),
     SCM_CLASS_SLOT_SPEC( "reason", gpgme_invalid_key_reason, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_INVALID_KEY_H__ */
