
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_key.h"

ScmObj gpgme_key_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_KEY *p = SCM_NEW( Scm_GPGME_KEY );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_KEY );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_KEYClass, NULL, NULL, NULL,
                          gpgme_key_allocate, NULL );

ScmObj gpgme_key_revoked( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->revoked );
}

ScmObj gpgme_key_expired( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->expired );
}

ScmObj gpgme_key_disabled( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->disabled );
}

ScmObj gpgme_key_invalid( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->invalid );
}

ScmObj gpgme_key_can_encrypt( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_encrypt );
}

ScmObj gpgme_key_can_sign( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_sign );
}

ScmObj gpgme_key_can_certify( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_certify );
}

ScmObj gpgme_key_secret( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->secret );
}

ScmObj gpgme_key_can_authenticate( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_authenticate );
}

ScmObj gpgme_key_is_qualified( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->is_qualified );
}

ScmObj gpgme_key_origin( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->origin );
}

ScmObj gpgme_key_protocol( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->protocol );
}

ScmObj gpgme_key_issuer_serial( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->issuer_serial == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->issuer_serial );
     }
}

ScmObj gpgme_key_issuer_name( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->issuer_name == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->issuer_name );
     }
}

ScmObj gpgme_key_chain_id( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->chain_id == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->chain_id );
     }
}

ScmObj gpgme_key_owner_trust( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->owner_trust );
}

ScmObj gpgme_key_subkeys( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->subkeys == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SUBKEY *q =
         SCM_GPGME_SUBKEY( gpgme_subkey_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->subkeys;
     return SCM_OBJ( q );
}

ScmObj gpgme_key_uids( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->uids == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_USER_ID *q = SCM_GPGME_USER_ID(
         gpgme_user_id_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->uids;
     return SCM_OBJ( q );
}

ScmObj gpgme_key__last_subkey( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->_last_subkey == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SUBKEY *q =
         SCM_GPGME_SUBKEY( gpgme_subkey_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->_last_subkey;
     return SCM_OBJ( q );
}

ScmObj gpgme_key__last_uid( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->_last_uid == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_USER_ID *q = SCM_GPGME_USER_ID(
         gpgme_user_id_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->_last_uid;
     return SCM_OBJ( q );
}

ScmObj gpgme_key_keylist_mode( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->keylist_mode );
}

ScmObj gpgme_key_fpr( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->fpr == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->fpr );
     }
}

ScmObj gpgme_key_last_update( Scm_GPGME_KEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->last_update );
}
