
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_key_sig.h"

ScmObj gpgme_key_sig_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_KEY_SIG *p = SCM_NEW( Scm_GPGME_KEY_SIG );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_KEY_SIG );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_KEY_SIGClass, NULL, NULL, NULL,
                          gpgme_key_sig_allocate, NULL );

ScmObj gpgme_key_sig_revoked( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->revoked );
}

ScmObj gpgme_key_sig_expired( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->expired );
}

ScmObj gpgme_key_sig_invalid( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->invalid );
}

ScmObj gpgme_key_sig_exportable( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->exportable );
}

ScmObj gpgme_key_sig_pubkey_algo( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->pubkey_algo );
}

ScmObj gpgme_key_sig_keyid( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->keyid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->keyid );
     }
}

ScmObj gpgme_key_sig__keyid( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->_keyid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->_keyid );
     }
}

ScmObj gpgme_key_sig_timestamp( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->timestamp );
}

ScmObj gpgme_key_sig_expires( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->expires );
}

ScmObj gpgme_key_sig_status( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->status );
}

ScmObj gpgme_key_sig_uid( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->uid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->uid );
     }
}

ScmObj gpgme_key_sig_name( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->name == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->name );
     }
}

ScmObj gpgme_key_sig_email( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->email == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->email );
     }
}

ScmObj gpgme_key_sig_comment( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->comment == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->comment );
     }
}

ScmObj gpgme_key_sig_sig_class( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->sig_class );
}

ScmObj gpgme_key_sig_notations( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->notations == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SIG_NOTATION *q = SCM_GPGME_SIG_NOTATION(
         gpgme_sig_notation_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->notations;
     return SCM_OBJ( q );
}

ScmObj gpgme_key_sig__last_notation( Scm_GPGME_KEY_SIG *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->_last_notation == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SIG_NOTATION *q = SCM_GPGME_SIG_NOTATION(
         gpgme_sig_notation_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->_last_notation;
     return SCM_OBJ( q );
}
