#ifndef __STRUCT_GPGME_KEY_SIG_H__
#define __STRUCT_GPGME_KEY_SIG_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

#include "struct_gpgme_sig_notation.h"
#include "struct_gpgme_sig_notation.h"

typedef struct Scm_GPGME_KEY_SIGRec {
     SCM_HEADER;
     gpgme_key_sig_t obj;
} Scm_GPGME_KEY_SIG;

SCM_CLASS_DECL( Scm_GPGME_KEY_SIGClass );
#define SCM_CLASS_GPGME_KEY_SIG ( &Scm_GPGME_KEY_SIGClass )
#define SCM_GPGME_KEY_SIG( obj ) ( ( Scm_GPGME_KEY_SIG * )obj )
#define SCM_GPGME_KEY_SIG_P( obj ) SCM_XTYPEP( obj, &Scm_GPGME_KEY_SIGClass )

ScmObj gpgme_key_sig_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_key_sig_revoked( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_expired( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_invalid( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_exportable( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_pubkey_algo( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_keyid( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig__keyid( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_timestamp( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_expires( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_status( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_uid( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_name( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_email( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_comment( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_sig_class( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig_notations( Scm_GPGME_KEY_SIG *p );
ScmObj gpgme_key_sig__last_notation( Scm_GPGME_KEY_SIG *p );

static ScmClassStaticSlotSpec gpgme_key_sig_slots[] = {
     SCM_CLASS_SLOT_SPEC( "revoked", gpgme_key_sig_revoked, NULL ),
     SCM_CLASS_SLOT_SPEC( "expired", gpgme_key_sig_expired, NULL ),
     SCM_CLASS_SLOT_SPEC( "invalid", gpgme_key_sig_invalid, NULL ),
     SCM_CLASS_SLOT_SPEC( "exportable", gpgme_key_sig_exportable, NULL ),
     SCM_CLASS_SLOT_SPEC( "pubkey_algo", gpgme_key_sig_pubkey_algo, NULL ),
     SCM_CLASS_SLOT_SPEC( "keyid", gpgme_key_sig_keyid, NULL ),
     SCM_CLASS_SLOT_SPEC( "_keyid", gpgme_key_sig__keyid, NULL ),
     SCM_CLASS_SLOT_SPEC( "timestamp", gpgme_key_sig_timestamp, NULL ),
     SCM_CLASS_SLOT_SPEC( "expires", gpgme_key_sig_expires, NULL ),
     SCM_CLASS_SLOT_SPEC( "status", gpgme_key_sig_status, NULL ),
     SCM_CLASS_SLOT_SPEC( "uid", gpgme_key_sig_uid, NULL ),
     SCM_CLASS_SLOT_SPEC( "name", gpgme_key_sig_name, NULL ),
     SCM_CLASS_SLOT_SPEC( "email", gpgme_key_sig_email, NULL ),
     SCM_CLASS_SLOT_SPEC( "comment", gpgme_key_sig_comment, NULL ),
     SCM_CLASS_SLOT_SPEC( "sig_class", gpgme_key_sig_sig_class, NULL ),
     SCM_CLASS_SLOT_SPEC( "notations", gpgme_key_sig_notations, NULL ),
     SCM_CLASS_SLOT_SPEC( "_last_notation", gpgme_key_sig__last_notation,
                          NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_KEY_SIG_H__ */
