
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_new_signature.h"

ScmObj gpgme_new_signature_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_NEW_SIGNATURE *p = SCM_NEW( Scm_GPGME_NEW_SIGNATURE );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_NEW_SIGNATURE );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_NEW_SIGNATUREClass, NULL, NULL, NULL,
                          gpgme_new_signature_allocate, NULL );

ScmObj gpgme_new_signature_next( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->next == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_NEW_SIGNATURE *q = SCM_GPGME_NEW_SIGNATURE(
         gpgme_new_signature_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->next;
     return SCM_OBJ( q );
}

ScmObj gpgme_new_signature_type( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->type );
}

ScmObj gpgme_new_signature_pubkey_algo( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->pubkey_algo );
}

ScmObj gpgme_new_signature_hash_algo( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->hash_algo );
}

ScmObj gpgme_new_signature__obsolete_class( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->_obsolete_class );
}

ScmObj gpgme_new_signature_timestamp( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->timestamp );
}

ScmObj gpgme_new_signature_fpr( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->fpr == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->fpr );
     }
}

ScmObj gpgme_new_signature_sig_class( Scm_GPGME_NEW_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->sig_class );
}
