#ifndef __STRUCT_GPGME_NEW_SIGNATURE_H__
#define __STRUCT_GPGME_NEW_SIGNATURE_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_NEW_SIGNATURERec {
     SCM_HEADER;
     gpgme_new_signature_t obj;
} Scm_GPGME_NEW_SIGNATURE;

SCM_CLASS_DECL( Scm_GPGME_NEW_SIGNATUREClass );
#define SCM_CLASS_GPGME_NEW_SIGNATURE ( &Scm_GPGME_NEW_SIGNATUREClass )
#define SCM_GPGME_NEW_SIGNATURE( obj ) ( ( Scm_GPGME_NEW_SIGNATURE * )obj )
#define SCM_GPGME_NEW_SIGNATURE_P( obj )                                       \
     SCM_XTYPEP( obj, &Scm_GPGME_NEW_SIGNATUREClass )

ScmObj gpgme_new_signature_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_new_signature_next( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_type( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_pubkey_algo( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_hash_algo( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature__obsolete_class( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_timestamp( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_fpr( Scm_GPGME_NEW_SIGNATURE *p );
ScmObj gpgme_new_signature_sig_class( Scm_GPGME_NEW_SIGNATURE *p );

static ScmClassStaticSlotSpec gpgme_new_signature_slots[] = {
     SCM_CLASS_SLOT_SPEC( "next", gpgme_new_signature_next, NULL ),
     SCM_CLASS_SLOT_SPEC( "type", gpgme_new_signature_type, NULL ),
     SCM_CLASS_SLOT_SPEC( "pubkey_algo", gpgme_new_signature_pubkey_algo,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "hash_algo", gpgme_new_signature_hash_algo, NULL ),
     SCM_CLASS_SLOT_SPEC( "_obsolete_class",
                          gpgme_new_signature__obsolete_class, NULL ),
     SCM_CLASS_SLOT_SPEC( "timestamp", gpgme_new_signature_timestamp, NULL ),
     SCM_CLASS_SLOT_SPEC( "fpr", gpgme_new_signature_fpr, NULL ),
     SCM_CLASS_SLOT_SPEC( "sig_class", gpgme_new_signature_sig_class, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_NEW_SIGNATURE_H__ */
