#ifndef __STRUCT_GPGME_SIG_NOTATION_H__
#define __STRUCT_GPGME_SIG_NOTATION_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_SIG_NOTATIONRec {
     SCM_HEADER;
     gpgme_sig_notation_t obj;
} Scm_GPGME_SIG_NOTATION;

SCM_CLASS_DECL( Scm_GPGME_SIG_NOTATIONClass );
#define SCM_CLASS_GPGME_SIG_NOTATION ( &Scm_GPGME_SIG_NOTATIONClass )
#define SCM_GPGME_SIG_NOTATION( obj ) ( ( Scm_GPGME_SIG_NOTATION * )obj )
#define SCM_GPGME_SIG_NOTATION_P( obj )                                        \
     SCM_XTYPEP( obj, &Scm_GPGME_SIG_NOTATIONClass )

ScmObj gpgme_sig_notation_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_sig_notation_name( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_value( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_name_len( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_value_len( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_flags( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_human_readable( Scm_GPGME_SIG_NOTATION *p );
ScmObj gpgme_sig_notation_critical( Scm_GPGME_SIG_NOTATION *p );

static ScmClassStaticSlotSpec gpgme_sig_notation_slots[] = {
     SCM_CLASS_SLOT_SPEC( "name", gpgme_sig_notation_name, NULL ),
     SCM_CLASS_SLOT_SPEC( "value", gpgme_sig_notation_value, NULL ),
     SCM_CLASS_SLOT_SPEC( "name_len", gpgme_sig_notation_name_len, NULL ),
     SCM_CLASS_SLOT_SPEC( "value_len", gpgme_sig_notation_value_len, NULL ),
     SCM_CLASS_SLOT_SPEC( "flags", gpgme_sig_notation_flags, NULL ),
     SCM_CLASS_SLOT_SPEC( "human_readable", gpgme_sig_notation_human_readable,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "critical", gpgme_sig_notation_critical, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_SIG_NOTATION_H__ */
