
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_signature.h"

ScmObj gpgme_signature_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_SIGNATURE *p = SCM_NEW( Scm_GPGME_SIGNATURE );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_SIGNATURE );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_SIGNATUREClass, NULL, NULL, NULL,
                          gpgme_signature_allocate, NULL );

ScmObj gpgme_signature_next( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->next );
}

ScmObj gpgme_signature_summary( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->summary );
}

ScmObj gpgme_signature_fpr( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->fpr == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->fpr );
     }
}

ScmObj gpgme_signature_status( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->status );
}

ScmObj gpgme_signature_notations( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->notations == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SIG_NOTATION *q = SCM_GPGME_SIG_NOTATION(
         gpgme_sig_notation_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->notations;
     return SCM_OBJ( q );
}

ScmObj gpgme_signature_timestamp( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->timestamp );
}

ScmObj gpgme_signature_exp_timestamp( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->exp_timestamp );
}

ScmObj gpgme_signature_wrong_key_usage( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->wrong_key_usage );
}

ScmObj gpgme_signature_pka_trust( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->pka_trust );
}

ScmObj gpgme_signature_chain_model( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->chain_model );
}

ScmObj gpgme_signature_validity( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->validity );
}

ScmObj gpgme_signature_validity_reason( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->validity_reason );
}

ScmObj gpgme_signature_pubkey_algo( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->pubkey_algo );
}

ScmObj gpgme_signature_hash_algo( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->hash_algo );
}

ScmObj gpgme_signature_pka_address( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->pka_address == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->pka_address );
     }
}

ScmObj gpgme_signature_key( Scm_GPGME_SIGNATURE *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->key == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_KEY *q =
         SCM_GPGME_KEY( gpgme_key_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->key;
     return SCM_OBJ( q );
}
