#ifndef __STRUCT_GPGME_SIGNATURE_H__
#define __STRUCT_GPGME_SIGNATURE_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

#include "struct_gpgme_sig_notation.h"
#include "struct_gpgme_key.h"

typedef struct Scm_GPGME_SIGNATURERec {
     SCM_HEADER;
     gpgme_signature_t obj;
} Scm_GPGME_SIGNATURE;

SCM_CLASS_DECL( Scm_GPGME_SIGNATUREClass );
#define SCM_CLASS_GPGME_SIGNATURE ( &Scm_GPGME_SIGNATUREClass )
#define SCM_GPGME_SIGNATURE( obj ) ( ( Scm_GPGME_SIGNATURE * )obj )
#define SCM_GPGME_SIGNATURE_P( obj )                                           \
     SCM_XTYPEP( obj, &Scm_GPGME_SIGNATUREClass )

ScmObj gpgme_signature_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_signature_next( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_summary( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_fpr( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_status( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_notations( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_timestamp( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_exp_timestamp( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_wrong_key_usage( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_pka_trust( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_chain_model( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_validity( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_validity_reason( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_pubkey_algo( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_hash_algo( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_pka_address( Scm_GPGME_SIGNATURE *p );
ScmObj gpgme_signature_key( Scm_GPGME_SIGNATURE *p );

static ScmClassStaticSlotSpec gpgme_signature_slots[] = {
     SCM_CLASS_SLOT_SPEC( "next", gpgme_signature_next, NULL ),
     SCM_CLASS_SLOT_SPEC( "summary", gpgme_signature_summary, NULL ),
     SCM_CLASS_SLOT_SPEC( "fpr", gpgme_signature_fpr, NULL ),
     SCM_CLASS_SLOT_SPEC( "status", gpgme_signature_status, NULL ),
     SCM_CLASS_SLOT_SPEC( "notations", gpgme_signature_notations, NULL ),
     SCM_CLASS_SLOT_SPEC( "timestamp", gpgme_signature_timestamp, NULL ),
     SCM_CLASS_SLOT_SPEC( "exp_timestamp", gpgme_signature_exp_timestamp,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "wrong_key_usage", gpgme_signature_wrong_key_usage,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "pka_trust", gpgme_signature_pka_trust, NULL ),
     SCM_CLASS_SLOT_SPEC( "chain_model", gpgme_signature_chain_model, NULL ),
     SCM_CLASS_SLOT_SPEC( "validity", gpgme_signature_validity, NULL ),
     SCM_CLASS_SLOT_SPEC( "validity_reason", gpgme_signature_validity_reason,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "pubkey_algo", gpgme_signature_pubkey_algo, NULL ),
     SCM_CLASS_SLOT_SPEC( "hash_algo", gpgme_signature_hash_algo, NULL ),
     SCM_CLASS_SLOT_SPEC( "pka_address", gpgme_signature_pka_address, NULL ),
     SCM_CLASS_SLOT_SPEC( "key", gpgme_signature_key, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_SIGNATURE_H__ */
