
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_subkey.h"

ScmObj gpgme_subkey_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_SUBKEY *p = SCM_NEW( Scm_GPGME_SUBKEY );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_SUBKEY );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_SUBKEYClass, NULL, NULL, NULL,
                          gpgme_subkey_allocate, NULL );

ScmObj gpgme_subkey_next( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->next == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_SUBKEY *q =
         SCM_GPGME_SUBKEY( gpgme_subkey_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->next;
     return SCM_OBJ( q );
}

ScmObj gpgme_subkey_revoked( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->revoked );
}

ScmObj gpgme_subkey_expired( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->expired );
}

ScmObj gpgme_subkey_disabled( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->disabled );
}

ScmObj gpgme_subkey_invalid( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->invalid );
}

ScmObj gpgme_subkey_can_encrypt( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_encrypt );
}

ScmObj gpgme_subkey_can_sign( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_sign );
}

ScmObj gpgme_subkey_can_certify( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_certify );
}

ScmObj gpgme_subkey_secret( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->secret );
}

ScmObj gpgme_subkey_can_authenticate( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->can_authenticate );
}

ScmObj gpgme_subkey_is_qualified( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->is_qualified );
}

ScmObj gpgme_subkey_is_cardkey( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->is_cardkey );
}

ScmObj gpgme_subkey_is_de_vs( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->is_de_vs );
}

ScmObj gpgme_subkey_pubkey_algo( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->pubkey_algo );
}

ScmObj gpgme_subkey_length( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->length );
}

ScmObj gpgme_subkey_keyid( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->keyid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->keyid );
     }
}

ScmObj gpgme_subkey__keyid( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->_keyid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->_keyid );
     }
}

ScmObj gpgme_subkey_fpr( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->fpr == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->fpr );
     }
}

ScmObj gpgme_subkey_timestamp( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->timestamp );
}

ScmObj gpgme_subkey_expires( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->expires );
}

ScmObj gpgme_subkey_card_number( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->card_number == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->card_number );
     }
}

ScmObj gpgme_subkey_curve( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->curve == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->curve );
     }
}

ScmObj gpgme_subkey_keygrip( Scm_GPGME_SUBKEY *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->keygrip == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->keygrip );
     }
}
