#ifndef __STRUCT_GPGME_SUBKEY_H__
#define __STRUCT_GPGME_SUBKEY_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_SUBKEYRec {
     SCM_HEADER;
     gpgme_subkey_t obj;
} Scm_GPGME_SUBKEY;

SCM_CLASS_DECL( Scm_GPGME_SUBKEYClass );
#define SCM_CLASS_GPGME_SUBKEY ( &Scm_GPGME_SUBKEYClass )
#define SCM_GPGME_SUBKEY( obj ) ( ( Scm_GPGME_SUBKEY * )obj )
#define SCM_GPGME_SUBKEY_P( obj ) SCM_XTYPEP( obj, &Scm_GPGME_SUBKEYClass )

ScmObj gpgme_subkey_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_subkey_next( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_revoked( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_expired( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_disabled( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_invalid( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_can_encrypt( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_can_sign( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_can_certify( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_secret( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_can_authenticate( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_is_qualified( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_is_cardkey( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_is_de_vs( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_pubkey_algo( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_length( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_keyid( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey__keyid( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_fpr( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_timestamp( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_expires( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_card_number( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_curve( Scm_GPGME_SUBKEY *p );
ScmObj gpgme_subkey_keygrip( Scm_GPGME_SUBKEY *p );

static ScmClassStaticSlotSpec gpgme_subkey_slots[] = {
     SCM_CLASS_SLOT_SPEC( "next", gpgme_subkey_next, NULL ),
     SCM_CLASS_SLOT_SPEC( "revoked", gpgme_subkey_revoked, NULL ),
     SCM_CLASS_SLOT_SPEC( "expired", gpgme_subkey_expired, NULL ),
     SCM_CLASS_SLOT_SPEC( "disabled", gpgme_subkey_disabled, NULL ),
     SCM_CLASS_SLOT_SPEC( "invalid", gpgme_subkey_invalid, NULL ),
     SCM_CLASS_SLOT_SPEC( "can_encrypt", gpgme_subkey_can_encrypt, NULL ),
     SCM_CLASS_SLOT_SPEC( "can_sign", gpgme_subkey_can_sign, NULL ),
     SCM_CLASS_SLOT_SPEC( "can_certify", gpgme_subkey_can_certify, NULL ),
     SCM_CLASS_SLOT_SPEC( "secret", gpgme_subkey_secret, NULL ),
     SCM_CLASS_SLOT_SPEC( "can_authenticate", gpgme_subkey_can_authenticate,
                          NULL ),
     SCM_CLASS_SLOT_SPEC( "is_qualified", gpgme_subkey_is_qualified, NULL ),
     SCM_CLASS_SLOT_SPEC( "is_cardkey", gpgme_subkey_is_cardkey, NULL ),
     SCM_CLASS_SLOT_SPEC( "is_de_vs", gpgme_subkey_is_de_vs, NULL ),
     SCM_CLASS_SLOT_SPEC( "pubkey_algo", gpgme_subkey_pubkey_algo, NULL ),
     SCM_CLASS_SLOT_SPEC( "length", gpgme_subkey_length, NULL ),
     SCM_CLASS_SLOT_SPEC( "keyid", gpgme_subkey_keyid, NULL ),
     SCM_CLASS_SLOT_SPEC( "_keyid", gpgme_subkey__keyid, NULL ),
     SCM_CLASS_SLOT_SPEC( "fpr", gpgme_subkey_fpr, NULL ),
     SCM_CLASS_SLOT_SPEC( "timestamp", gpgme_subkey_timestamp, NULL ),
     SCM_CLASS_SLOT_SPEC( "expires", gpgme_subkey_expires, NULL ),
     SCM_CLASS_SLOT_SPEC( "card_number", gpgme_subkey_card_number, NULL ),
     SCM_CLASS_SLOT_SPEC( "curve", gpgme_subkey_curve, NULL ),
     SCM_CLASS_SLOT_SPEC( "keygrip", gpgme_subkey_keygrip, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_SUBKEY_H__ */
