#ifndef __STRUCT_GPGME_TOFU_INFO_H__
#define __STRUCT_GPGME_TOFU_INFO_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

typedef struct Scm_GPGME_TOFU_INFORec {
     SCM_HEADER;
     gpgme_tofu_info_t obj;
} Scm_GPGME_TOFU_INFO;

SCM_CLASS_DECL( Scm_GPGME_TOFU_INFOClass );
#define SCM_CLASS_GPGME_TOFU_INFO ( &Scm_GPGME_TOFU_INFOClass )
#define SCM_GPGME_TOFU_INFO( obj ) ( ( Scm_GPGME_TOFU_INFO * )obj )
#define SCM_GPGME_TOFU_INFO_P( obj )                                           \
     SCM_XTYPEP( obj, &Scm_GPGME_TOFU_INFOClass )

ScmObj gpgme_tofu_info_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_tofu_info_validity( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_policy( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info__rfu( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_signcount( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_encrcount( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_signfirst( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_signlast( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_encrfirst( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_encrlast( Scm_GPGME_TOFU_INFO *p );
ScmObj gpgme_tofu_info_description( Scm_GPGME_TOFU_INFO *p );

static ScmClassStaticSlotSpec gpgme_tofu_info_slots[] = {
     SCM_CLASS_SLOT_SPEC( "validity", gpgme_tofu_info_validity, NULL ),
     SCM_CLASS_SLOT_SPEC( "policy", gpgme_tofu_info_policy, NULL ),
     SCM_CLASS_SLOT_SPEC( "_rfu", gpgme_tofu_info__rfu, NULL ),
     SCM_CLASS_SLOT_SPEC( "signcount", gpgme_tofu_info_signcount, NULL ),
     SCM_CLASS_SLOT_SPEC( "encrcount", gpgme_tofu_info_encrcount, NULL ),
     SCM_CLASS_SLOT_SPEC( "signfirst", gpgme_tofu_info_signfirst, NULL ),
     SCM_CLASS_SLOT_SPEC( "signlast", gpgme_tofu_info_signlast, NULL ),
     SCM_CLASS_SLOT_SPEC( "encrfirst", gpgme_tofu_info_encrfirst, NULL ),
     SCM_CLASS_SLOT_SPEC( "encrlast", gpgme_tofu_info_encrlast, NULL ),
     SCM_CLASS_SLOT_SPEC( "description", gpgme_tofu_info_description, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_TOFU_INFO_H__ */
