
/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "struct_gpgme_user_id.h"

ScmObj gpgme_user_id_allocate( ScmClass *klass, ScmObj initargs )
{
     Scm_GPGME_USER_ID *p = SCM_NEW( Scm_GPGME_USER_ID );
     SCM_SET_CLASS( p, SCM_CLASS_GPGME_USER_ID );

     p->obj = NULL;

     return SCM_OBJ( p );
}

SCM_DEFINE_BUILTIN_CLASS( Scm_GPGME_USER_IDClass, NULL, NULL, NULL,
                          gpgme_user_id_allocate, NULL );

ScmObj gpgme_user_id_revoked( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->revoked );
}

ScmObj gpgme_user_id_invalid( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->invalid );
}

ScmObj gpgme_user_id_origin( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->origin );
}

ScmObj gpgme_user_id_validity( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->validity );
}

ScmObj gpgme_user_id_uid( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->uid == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->uid );
     }
}

ScmObj gpgme_user_id_name( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->name == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->name );
     }
}

ScmObj gpgme_user_id_email( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->email == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->email );
     }
}

ScmObj gpgme_user_id_comment( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->comment == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->comment );
     }
}

ScmObj gpgme_user_id_signatures( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->signatures == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_KEY_SIG *q = SCM_GPGME_KEY_SIG(
         gpgme_key_sig_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->signatures;
     return SCM_OBJ( q );
}

ScmObj gpgme_user_id__last_keysig( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->_last_keysig == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_KEY_SIG *q = SCM_GPGME_KEY_SIG(
         gpgme_key_sig_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->_last_keysig;
     return SCM_OBJ( q );
}

ScmObj gpgme_user_id_address( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }
     if( p->obj->address == NULL ) {
          return SCM_FALSE;
     } else {
          return SCM_MAKE_STR( p->obj->address );
     }
}

ScmObj gpgme_user_id_tofu( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     if( p->obj->tofu == NULL ) {
          return SCM_FALSE;
     }
     Scm_GPGME_TOFU_INFO *q = SCM_GPGME_TOFU_INFO(
         gpgme_tofu_info_allocate( NULL, SCM_MAKE_STR( "" ) ) );
     q->obj = p->obj->tofu;
     return SCM_OBJ( q );
}

ScmObj gpgme_user_id_last_update( Scm_GPGME_USER_ID *p )
{
     if( p->obj == NULL ) {
          return SCM_FALSE;
     }

     return SCM_MAKE_INT( p->obj->last_update );
}
