#ifndef __STRUCT_GPGME_USER_ID_H__
#define __STRUCT_GPGME_USER_ID_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

#include "struct_gpgme_key_sig.h"
#include "struct_gpgme_key_sig.h"
#include "struct_gpgme_tofu_info.h"

typedef struct Scm_GPGME_USER_IDRec {
     SCM_HEADER;
     gpgme_user_id_t obj;
} Scm_GPGME_USER_ID;

SCM_CLASS_DECL( Scm_GPGME_USER_IDClass );
#define SCM_CLASS_GPGME_USER_ID ( &Scm_GPGME_USER_IDClass )
#define SCM_GPGME_USER_ID( obj ) ( ( Scm_GPGME_USER_ID * )obj )
#define SCM_GPGME_USER_ID_P( obj ) SCM_XTYPEP( obj, &Scm_GPGME_USER_IDClass )

ScmObj gpgme_user_id_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_user_id_revoked( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_invalid( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_origin( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_validity( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_uid( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_name( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_email( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_comment( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_signatures( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id__last_keysig( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_address( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_tofu( Scm_GPGME_USER_ID *p );
ScmObj gpgme_user_id_last_update( Scm_GPGME_USER_ID *p );

static ScmClassStaticSlotSpec gpgme_user_id_slots[] = {
     SCM_CLASS_SLOT_SPEC( "revoked", gpgme_user_id_revoked, NULL ),
     SCM_CLASS_SLOT_SPEC( "invalid", gpgme_user_id_invalid, NULL ),
     SCM_CLASS_SLOT_SPEC( "origin", gpgme_user_id_origin, NULL ),
     SCM_CLASS_SLOT_SPEC( "validity", gpgme_user_id_validity, NULL ),
     SCM_CLASS_SLOT_SPEC( "uid", gpgme_user_id_uid, NULL ),
     SCM_CLASS_SLOT_SPEC( "name", gpgme_user_id_name, NULL ),
     SCM_CLASS_SLOT_SPEC( "email", gpgme_user_id_email, NULL ),
     SCM_CLASS_SLOT_SPEC( "comment", gpgme_user_id_comment, NULL ),
     SCM_CLASS_SLOT_SPEC( "signatures", gpgme_user_id_signatures, NULL ),
     SCM_CLASS_SLOT_SPEC( "_last_keysig", gpgme_user_id__last_keysig, NULL ),
     SCM_CLASS_SLOT_SPEC( "address", gpgme_user_id_address, NULL ),
     SCM_CLASS_SLOT_SPEC( "tofu", gpgme_user_id_tofu, NULL ),
     SCM_CLASS_SLOT_SPEC( "last_update", gpgme_user_id_last_update, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_USER_ID_H__ */
