#ifndef __STRUCT_GPGME_VERIFY_RESULT_H__
#define __STRUCT_GPGME_VERIFY_RESULT_H__

/*
 * one line to give the Gauche-_gpgme and an idea of what it does.
 * Copyright (C) 2017 aaauuue
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <gauche.h>
#include <gauche/extend.h>
#include <gauche/class.h>

#include "config.h"
#include "gpgmeutil.h"

#include "struct_gpgme_signature.h"

typedef struct Scm_GPGME_VERIFY_RESULTRec {
     SCM_HEADER;
     gpgme_verify_result_t obj;
} Scm_GPGME_VERIFY_RESULT;

SCM_CLASS_DECL( Scm_GPGME_VERIFY_RESULTClass );
#define SCM_CLASS_GPGME_VERIFY_RESULT ( &Scm_GPGME_VERIFY_RESULTClass )
#define SCM_GPGME_VERIFY_RESULT( obj ) ( ( Scm_GPGME_VERIFY_RESULT * )obj )
#define SCM_GPGME_VERIFY_RESULT_P( obj )                                       \
     SCM_XTYPEP( obj, &Scm_GPGME_VERIFY_RESULTClass )

ScmObj gpgme_verify_result_allocate( ScmClass *klass, ScmObj initargs );

ScmObj gpgme_verify_result_signatures( Scm_GPGME_VERIFY_RESULT *p );
ScmObj gpgme_verify_result_file_name( Scm_GPGME_VERIFY_RESULT *p );

static ScmClassStaticSlotSpec gpgme_verify_result_slots[] = {
     SCM_CLASS_SLOT_SPEC( "signatures", gpgme_verify_result_signatures, NULL ),
     SCM_CLASS_SLOT_SPEC( "file_name", gpgme_verify_result_file_name, NULL ),
     SCM_CLASS_SLOT_SPEC_END()
};
#endif /* #ifndef __STRUCT_GPGME_VERIFY_RESULT_H__ */
